#include <LCD_test.h>
#include <LCD_MM.c>

//Variables
int ROTATION=2;            //Encoder direction: 0=CCW, 1=CW, 2=STOP
int1 PUSH=0;               //Encoder switch status: 0=OFF, 1=ON
int SCREEN=1;              //LCD screen index
int LINE=1;                //LCD cursor position

//************************** Service Functions ***************************//
#int_EXT
void  EXT_isr(void) { 
   if(input(PIN_C6)==1)ROTATION=!input(PIN_C7); //If switch not pressed,
   else {                                       //detect the direction
      PUSH=1;                                   //If switch is pressed, set it
      ROTATION=2;                               //and indicate no rotation
   }   
}
void graphics() {          //User defined graphics: cursor and arrows

   // Cursor: 0 //
   lcd_send_byte(0,0b01000000);
   lcd_send_byte(1,0b00010000);
   lcd_send_byte(1,0b00011000);
   lcd_send_byte(1,0b00011100);
   lcd_send_byte(1,0b00011110);
   lcd_send_byte(1,0b00011100);
   lcd_send_byte(1,0b00011000);
   lcd_send_byte(1,0b00010000);
   lcd_send_byte(1,0b00000000);
  
   // Arrow up: 1 //
   lcd_send_byte(0,0b01001000);
   lcd_send_byte(1,0b00000100);
   lcd_send_byte(1,0b00001110);
   lcd_send_byte(1,0b00011111);
   lcd_send_byte(1,0b00000000);
   lcd_send_byte(1,0b00000000);
   lcd_send_byte(1,0b00000000);
   lcd_send_byte(1,0b00000000);
   lcd_send_byte(1,0b00000000);
   
   // Arrow down: 2 //
   lcd_send_byte(0,0b01010000);
   lcd_send_byte(1,0b00000000);
   lcd_send_byte(1,0b00000000);
   lcd_send_byte(1,0b00000000);
   lcd_send_byte(1,0b00000000);
   lcd_send_byte(1,0b00000000);
   lcd_send_byte(1,0b00011111);
   lcd_send_byte(1,0b00001110);
   lcd_send_byte(1,0b00000100);    
}

//************************ Satellite Functions ***************************//
void Function_A() {
   lcd_putc("\fScreen A (Function A)\n");
   lcd_putc("Push to return to menu");
   while(PUSH==0);
   PUSH=0;
}
void Function_B() {
   lcd_putc("\fScreen B (Function B)\n");
   lcd_putc("Push to return to menu");
   while(PUSH==0);
   PUSH=0;
}
void Function_C() {
   lcd_putc("\fScreen C (Function C)\n");
   lcd_putc("Push to return to menu");
   while(PUSH==0);
   PUSH=0;
}
void Function_D() {
   lcd_putc("\fScreen D (Function D)\n");
   lcd_putc("Push to return to menu");
   while(PUSH==0);
   PUSH=0;
}
void Function_E() {
   lcd_putc("\fScreen E (Function E)\n");
   lcd_putc("Push to return to menu");
   while(PUSH==0);
   PUSH=0;
}

//******************************* Main ***********************************//
void main() {
   lcd_init();                                  //LCD initialization
   enable_interrupts(GLOBAL);                   //Global interrupt enable
   enable_interrupts(INT_EXT);                  //External interrupt enabled
   ext_int_edge(H_TO_L);                        //Detection on falling edge
   graphics();                                  //User graphics definition
   
   while(TRUE) {
      switch (SCREEN) {
         case 1:  lcd_gotoxy(2,1);
                  lcd_putc("Push to view screen A  ");
                  lcd_gotoxy(2,2);
                  lcd_putc("Push to view screen B ");
                  lcd_putc(2);                        //Arrow down    
                  break;
         case 2:  lcd_gotoxy(2,1);
                  lcd_putc("Push to view screen B ");
                  lcd_putc(1);                        //Arrow up
                  lcd_gotoxy(2,2);
                  lcd_putc("Push to view screen C ");
                  lcd_putc(2);                        //Arrow down
                  break;
         case 3:  lcd_gotoxy(2,1);
                  lcd_putc("Push to view screen C ");
                  lcd_putc(1);                        //Arrow up
                  lcd_gotoxy(2,2);
                  lcd_putc("Push to view screen D ");
                  lcd_putc(2);                        //Arrow down
                  break;
         case 4:  lcd_gotoxy(2,1);
                  lcd_putc("Push to view screen D ");
                  lcd_putc(1);                        //Arrow up
                  lcd_gotoxy(2,2);
                  lcd_putc("Push to view screen E  ");
                  break;
         default: break;
      }   
      lcd_gotoxy(1,LINE);
      lcd_putc(0);                                    //Cursor
      lcd_gotoxy(1,(3-LINE));
      lcd_putc(" ");

      // Navigation algorithm //
      if((ROTATION==1)&&(LINE>1)&&(SCREEN<4))SCREEN=SCREEN+1;
      if((ROTATION==0)&&(LINE<2)&&(SCREEN>1))SCREEN=SCREEN-1;
      if((ROTATION==1)&&(LINE<2))LINE=LINE+1;
      if((ROTATION==0)&&(LINE>1))LINE=LINE-1;
      ROTATION=2;
      if(PUSH==1) {
         PUSH=0;
         switch (LINE+SCREEN) {
            case 2:  Function_A();
                     break;
            case 3:  Function_B();
                     break;
            case 4:  Function_C();
                     break;
            case 5:  Function_D();
                     break;
            case 6:  Function_E();
                     break;
            default: break;
         } 
      }
   }
}
